> For the complete documentation index, see [llms.txt](https://docs.scraperapi.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.scraperapi.com/structured-data-endpoints/real-estate/redfin/redfin-for-rent-listings-api.md).

# Redfin 'For Rent' Listings API

The `Redfin 'For Rent' Listings API` endpoint will retrieve listing information from a single 'For Rent' property listing page and transform it into usable JSON.

{% tabs %}
{% tab title="cURL" %}

```bash
curl --request GET \
--url "https://api.scraperapi.com/structured/redfin/forrent?api_key=API_KEY&\
url=URL&country_code=COUNTRY_CODE&tld=TLD&raw=RAW"
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

payload = {
    'api_key': 'API_KEY',
    'url': 'URL',
    'country_code': 'COUNTRY_CODE',
    'tld': 'TLD',
    'raw': 'RAW'
}

r = requests.get('https://api.scraperapi.com/structured/redfin/forrent',params=payload)

print(r.text)
```

{% endtab %}

{% tab title="NodeJS" %}

```javascript
import fetch from 'node-fetch';

fetch(
  'https://api.scraperapi.com/structured/redfin/forrent?api_key=API_KEY&url=URL&country_code=COUNTRY_CODE&tld=TLD&raw=RAW'
)
  .then(response => response.json()) 
  .then(data => {
    console.log(data);
  })
  .catch(error => {
    console.error(error);
  });
```

{% endtab %}

{% tab title="PHP" %}

```php
<?php
$url = "https://api.scraperapi.com/structured/redfin/forrent?api_key=API_KEY&url=URL&country_code=COUNTRY_CODE&tld=TLD";

$ch = curl_init();

curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_HEADER, FALSE);

$response = curl_exec($ch);
curl_close($ch);

print_r($response);
```

{% endtab %}

{% tab title="Ruby" %}

```ruby
require 'net/http'
require 'json'

params = {
  :api_key => "API_KEY",
  :url => "URL",
  :country_code => "COUNTRY_CODE",
  :tld => "TLD",
  :raw => "RAW"
}

uri = URI('https://api.scraperapi.com/structured/redfin/forrent')
uri.query = URI.encode_www_form(params)

website_content = Net::HTTP.get(uri)
print(website_content)
```

{% endtab %}

{% tab title="Java" %}

```java
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class Main {
    public static void main(String[] args) {
        try {
            String apiKey = "API_KEY";
            String url = "URL";
            String country_code = "COUNTRY_CODE";
            String tld = "TLD";
            String raw = "RAW";

            String urlStr = "https://api.scraperapi.com/structured/redfin/forrent?api_key=" 
                            + apiKey + "&url=" + url + "&country_code=" + country_code + "&tld=" + tld + "&raw=" + raw;

            URL url = new URL(urlStr);
            HttpURLConnection conn = (HttpURLConnection) url.openConnection();
            conn.setRequestMethod("GET");

            int responseCode = conn.getResponseCode();
            if (responseCode == HttpURLConnection.HTTP_OK) {
                BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
                StringBuilder response = new StringBuilder();
                String line;
                while ((line = in.readLine()) != null) {
                    response.append(line);
                }
                in.close();
                System.out.println(response.toString());
            } else {
                System.out.println("Error in API Call. Response code: " + responseCode);
            }

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
```

{% endtab %}
{% endtabs %}

**Supported Parameters**

<table><thead><tr><th width="326">Parameters</th><th>Details</th></tr></thead><tbody><tr><td><code>API_KEY</code> (required)</td><td>Your API Key.</td></tr><tr><td><code>URL</code> (required)</td><td>The URL of the Redfin page. The URL has to be the URL of a property for rent.</td></tr><tr><td><code>country_code</code></td><td>Allows you to geotarget the request. Use this parameter if you want Redfin to be scraped from a specific <a href="/pages/yl9YiS5XvNTKFwqK9ep5">country</a>.</td></tr><tr><td><code>TLD</code></td><td><p>The top level domain to scrape.</p><p>Valid options:</p><p>‘<code>com</code>’ (for <a href="http://redfin.com/">redfin.com</a>)</p><p>‘<code>ca</code>’ (for <a href="https://www.redfin.ca/">redfin.ca</a>)</p></td></tr><tr><td><code>raw</code></td><td><p>This is a boolean param - <code>true</code> or <code>false</code></p><p>If the <code>raw</code> parameter is set to <code>true</code>, the raw data will be extracted from the page without further parsing.</p><p><strong><code>Important:</code></strong> The structure of the data in raw mode cannot be guaranteed, it’s a tradeoff: You get a lot more information back, but the structure of the response may change if <strong><code>Redfin</code></strong> modifies their page layout.</p></td></tr></tbody></table>

## Sample Response

<details>

<summary>Response.json</summary>

```json
{
  "url": "https://www.redfin.com/NY/New-York/923-5th-Ave-10021/unit-7C/home/45140017",
  "type": "for_rent",
  "map_url": "https://maps.google.com/maps/api/staticmap?sensor=false&style=feature%3Aadminist...",
  "bed_min": 2,
  "bed_max": 2,
  "bath_min": 2,
  "bath_max": 2,
  "price_min": 13000,
  "price_max": 13000,
  "sqft_min": 1469,
  "sqft_max": 1469,
  "description": "This stunning corner residence on Fifth Avenue with full Central Park views pres...",
  "address": {
    "street_line": "923 5th Ave Unit 7C",
    "city": "New York",
    "state": "NY",
    "zip": "10021"
  },
  "last_updated": "2026-06-08T14:08:59.098980Z",
  "image_urls": [
    "https://ssl.cdn-redfin.com/photo/rent/4ea86a58-cf87-44f6-87c8-ed77acccde9e/bigph...",
    "https://ssl.cdn-redfin.com/photo/rent/4ea86a58-cf87-44f6-87c8-ed77acccde9e/bigph...",
    "... (16 more items)"
  ],
  "floor_plans": [
    {
      "unit_type": {
        "unit_type_id": "1bd09bd7-d3a9-4294-aeb9-6fa188566f26",
        "units": [
          {
            "unit_id": "53a574df-12b1-47f3-b363-8d02d75488e2",
            "bedrooms": 2,
            "deposit": 13000,
            "deposit_currency": "USD",
            "full_baths": 2,
            "half_baths": 0,
            "rent_currency": "USD",
            "rent_price": 13000,
            "sqft": 1469,
            "status": "available"
          }
        ],
        "available_lease_terms": [
          "12"
        ],
        "bedrooms": 2,
        "deposit": 13000,
        "deposit_currency": "USD",
        "full_baths": 2,
        "half_baths": 0,
        "rent_price_max": 13000,
        "rent_price_min": 13000,
        "sqft_max": 1469,
        "sqft_min": 1469,
        "status": "available",
        "total_units": 1
      },
      "bedroom_title": "2 Bed",
      "available": true,
      "unit_id": "53a574df-12b1-47f3-b363-8d02d75488e2",
      "bedrooms": 2,
      "deposit": 13000,
      "deposit_currency": "USD",
      "full_baths": 2,
      "half_baths": 0,
      "rent_currency": "USD",
      "rent_price": 13000,
      "sqft": 1469,
      "status": "available",
      "available_lease_terms": [
        "12"
      ],
      "rent_price_max": 13000,
      "rent_price_min": 13000,
      "total_units": 1
    }
  ],
  "nearby_places": [
    {
      "name": "Eli's Essentials",
      "address": "922 Madison Ave, New York, NY, 10021, us",
      "latitude": 40.772769927978516,
      "longitude": -73.96490478515625,
      "popularity": 0.9599999785423279,
      "phone_number": "(646) 790-2333",
      "website": "http://www.elizabar.com/",
      "categories": [
        "Caf\u00e9",
        "Deli",
        "... (1 more items)"
      ],
      "distance": 0.06462280371161838
    },
    {
      "name": "The Gallery",
      "address": "35 E 76th St, New York, NY, 10021, us",
      "latitude": 40.774227142333984,
      "longitude": -73.9628677368164,
      "popularity": 0.8899999856948853,
      "phone_number": "(212) 744-1600",
      "website": "http://www.rosewoodhotels.com/en/the-carlyle-new-york/dining/the-gallery",
      "categories": [
        "Tea Room",
        "Restaurant"
      ],
      "distance": 0.1796928228788314
    },
    "... (104 more items)"
  ],
  "transit": [
    {
      "stop_name": "MADISON AV/E 74 ST",
      "latitude": 40.772774,
      "longitude": -73.96461,
      "routes": [
        {
          "short_name": "M2",
          "long_name": "Washington Heights - East Village"
        },
        {
          "short_name": "M4",
          "long_name": "The Cloisters - 32 St"
        },
        "... (2 more items)"
      ]
    },
    {
      "stop_name": "5 AV/E 72 ST",
      "latitude": 40.772446,
      "longitude": -73.967247,
      "routes": [
        {
          "short_name": "BxM10",
          "long_name": "Williamsbridge/Morris Park - Midtown"
        },
        {
          "short_name": "BxM9",
          "long_name": "Throgs Neck - Midtown Express"
        },
        "... (4 more items)"
      ]
    },
    "... (28 more items)"
  ],
  "amenities": {
    "unit_amenities": [
      "Dishwasher",
      "Air Conditioning",
      "... (4 more items)"
    ],
    "standardized_amenities": [
      "A/C",
      "Dishwasher",
      "... (2 more items)"
    ]
  },
  "fees_and_policies": {
    "pet_policies": [
      {
        "policy_name": "no_pets",
        "pet_deposit_currency": "USD",
        "pet_fee_currency": "USD",
        "pet_rent_currency": "USD"
      }
    ],
    "available_lease_terms": [
      "12"
    ],
    "deposit_fee_min": 13000,
    "deposit_fee_max": 13000
  },
  "schools": [
    {
      "name": "PS 6 Lillie D Blake",
      "address": "45 E 81st St, New York, NY 10028",
      "url": "https://www.redfin.com/school/116264/NY/New-York/PS-6-Lillie-D-Blake",
      "review_count": 30,
      "great_schools_rating": 8,
      "great_school_url": "https://www.greatschools.org/new-york/new-york/2042-Ps-6-Lillie-D-Blake/",
      "parent_rating": 4,
      "distance_in_miles": "0.4",
      "grade_ranges": "PreK-5",
      "institution_type": "Public",
      "number_of_students": 655,
      "student_to_teacher_ratio": 15
    },
    {
      "name": "Junior High School 167 Robert F Wagner",
      "address": "220 E 76th St, New York, NY 10021",
      "url": "https://www.redfin.com/school/66345/NY/New-York/Junior-High-School-167-Robert-F-...",
      "review_count": 22,
      "great_schools_rating": 8,
      "great_school_url": "https://www.greatschools.org/new-york/new-york/2551-Jhs-167-Robert-F-Wagner/",
      "parent_rating": 3,
      "distance_in_miles": "0.5",
      "grade_ranges": "6-8",
      "institution_type": "Public",
      "number_of_students": 949,
      "student_to_teacher_ratio": 14
    }
  ],
  "sale_events": [
    {
      "price": 13000,
      "description": "Listed for Rent",
      "date": "2025-10-15T19:13:48.144Z",
      "source": "REDFIN",
      "souce_id": "1"
    },
    {
      "price": 4560000,
      "description": "Price Changed",
      "date": "2022-02-10T17:19:15.410Z",
      "source": "RLS at REBNY",
      "souce_id": "OLRS-257287-881041"
    },
    "... (11 more items)"
  ],
  "tax_events": [
    {
      "year": 2025,
      "property_tax": 20536.81,
      "land": 66101,
      "additions": 167027,
      "assessed_value": 233128
    },
    {
      "year": 2024,
      "property_tax": 19948.8,
      "land": 66101,
      "additions": 167027,
      "assessed_value": 233128
    },
    "... (14 more items)"
  ]
}

```

</details>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.scraperapi.com/structured-data-endpoints/real-estate/redfin/redfin-for-rent-listings-api.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
